attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec2 a_texCoord2;
uniform highp mat4 u_projectionMatrix;
uniform highp mat4 u_modelViewMatrix;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying mediump vec2 v_texCoord2;

//Billboarding specific to particle system. a_position is modified in engine before sent to shader

void main() {
	vec4 pos = u_modelViewMatrix * vec4(0.0, 0.0, 0.0, 1.0) + vec4(a_position.x, a_position.y, 0.0, 0.0);
	gl_Position = u_projectionMatrix * pos;
	v_color = a_color;
	v_texCoord = a_texCoord;
	v_texCoord2 = a_texCoord2;
}
