varying mediump vec2 v_texCoord0;
varying mediump vec3 v_L1dir;
varying mediump vec3 v_L2dir;

varying mediump vec3 v_normalSpaceTransformX;
varying mediump vec3 v_normalSpaceTransformY;
varying mediump vec3 v_normalSpaceTransformZ;

uniform lowp sampler2D u_texture; /* diffuse */
uniform lowp sampler2D u_texture1; /* normal map */

uniform mediump vec4 u_materialAmbient;
//uniform mediump vec4 u_materialDiffuse;
//uniform mediump vec4 u_materialSpecular;
//uniform mediump vec4 u_materialEmissive;
//uniform mediump float u_materialShininess;
uniform lowp vec4 u_color4;

// let's use these later on maybe
const lowp float spec1pow = 15.0;
const lowp float spec2pow = 45.0;

void main() {
	mediump vec4 color = texture2D(u_texture, v_texCoord0) * u_color4;
	mediump float alpha = color.a * u_color4.a;
	mediump vec4 normalMap = texture2D(u_texture1, v_texCoord0);
	
	// TBN matrix
	mediump mat3 normalSpaceTransform = mat3(	v_normalSpaceTransformY, 
							v_normalSpaceTransformX, 
							v_normalSpaceTransformZ
						);
	
	mediump vec3 normal = normalize(normalSpaceTransform * (normalMap.rgb * 2.0 - 1.0));
	normal.b *= normal.b;// give z a punch
	normal = normalize(normal);
	mediump float diffuse = clamp(dot(normal,v_L1dir),0.0,1.0);//*0.75;
	mediump float diffuse2 = clamp(dot(normal,v_L2dir),0.0,1.0);
	
	// remove these later on and use constants
	//lowp float spec1pow = u_materialSpecular.a*255.0;
	//lowp float spec2pow = u_materialEmissive.a*255.0;
	
	mediump float specular = pow(diffuse, spec1pow);// * u_materialSpecular.rgb;
	mediump float specular2 = pow(diffuse2, spec2pow);// * u_materialEmissive.rgb;
	mediump vec3 spec = vec3(specular*0.65+specular2*1.0) * normalMap.a; // Let normalmap alpha control specular
	spec = spec * mix(vec3(1.0),color.rgb,u_materialAmbient.a);
	diffuse = (diffuse+diffuse2)*0.5;
	//color = diffuse;
	//mediump vec3 ambient = u_materialAmbient.rgb;
	
	gl_FragColor = vec4(vec3( /*mix(ambient*color,*/color.rgb/*(diffuse)*/+spec ),alpha);
	//gl_FragColor = vec4(vec3(diffuse+spec),alpha);
}