#ifdef GL_ES
precision highp float;
#endif

attribute highp vec4 a_position;
attribute mediump vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_normal;
attribute mediump vec3 a_tangent;
attribute mediump vec3 a_binormal;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelMatrix;
uniform highp mat4 u_viewMatrix;
uniform highp mat4 u_viewMatrixInverse;

varying mediump vec2 v_texCoord;
varying highp vec2 v_texCoord2; // Vec2SphereMap for env map
varying mediump vec3 v_normal;
varying mediump vec3 v_tangent;
varying mediump vec3 v_binormal;
varying mediump vec3 v_camDir;
varying mediump vec4 v_color;

uniform vec4 u_expressionOffsets;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;

    v_normal = normalize((u_modelMatrix * vec4(a_normal, 0.0))).xyz;
    v_tangent = normalize((u_modelMatrix * vec4(a_tangent, 0.0))).xyz;
    v_binormal = normalize((u_modelMatrix * vec4(a_binormal, 0.0))).xyz;

	v_camDir = vec3(u_viewMatrix[0][2], u_viewMatrix[1][2], u_viewMatrix[2][2]);
  
    vec3 r = reflect(normalize(v_camDir), v_normal);

    v_texCoord = a_texCoord;
	v_texCoord2 = a_texCoord;
    //Facial expressions UV offset based on uniform that is set in C++ runtime
	//v_texCoord2.y = v_texCoord2.y - (a_color.r * u_expressionOffsets.x);
	//v_texCoord2.y = v_texCoord2.y - (a_color.g * u_expressionOffsets.y);
	//v_texCoord2.x = v_texCoord2.x + (a_color.b * u_expressionOffsets.z);
	v_color = a_color;
}

