attribute highp vec4 a_position;
attribute lowp vec4 a_color;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_viewMatrixInverse;
uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_modelMatrix;
uniform highp mat4 u_modelMatrixInverse;
	
varying lowp vec4 v_color;
uniform highp vec4 Bend;

void main() {
	v_color = a_color;
	
	vec3 pos = mul(u_modelMatrix , a_position).xyz;
	vec4 h_position = mul(u_modelViewProjectionMatrix, a_position);
	
	vec3 cameraWS = vec3(u_viewMatrixInverse[0].w, u_viewMatrixInverse[1].w, u_viewMatrixInverse[2].w) - pos;	
	float dropValue = clamp((length(cameraWS) - 25)/500, 0.0, 1.0);
	
	// Bend.y = arch (500.0 is a good start) - Bend.z = curvature (2.0 is a good start)
	h_position.y -= pow(dropValue, Bend.z) * Bend.y;	
	a_position.y = h_position.y;
	
	gl_Position = u_modelViewProjectionMatrix * a_position;
}



		