varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

//sprite texture
uniform sampler2D u_texture;
//displacement texture
uniform sampler2D u_texture1;
uniform float u_time;
uniform vec4 u_materialDiffuse;

uniform vec4 u_interval;
uniform vec4 u_displacement;
uniform vec4 u_multiplier;

void main()
{    
    vec2 uv = v_texCoord;

    //***** uncomment this to animate in F.E.*****
	//vec4 displacement = u_displacement * u_time;
	vec4 displacement = u_displacement * fract(u_time);
    //***********

    //Interval
    vec2 intervalPos;
    intervalPos.x = u_interval.x + displacement.z;
    intervalPos.y = u_interval.y + displacement.w;
    vec2 intervalSize;
    intervalSize.x = u_interval.z;
    intervalSize.y = u_interval.w;
    
    vec2 displacementUV;
    displacementUV.x = intervalPos.x + (uv.x * intervalSize.x) + displacement.x;
    displacementUV.y = intervalPos.y + (uv.y * intervalSize.y) + displacement.y;

    vec4 displacementColor = texture2D(u_texture1, displacementUV);
    vec3 grayScaleConversion = vec3(0.299, 0.587, 0.114);
    lowp float gsDisplacementColor = dot(displacementColor.rgb, grayScaleConversion);
    gsDisplacementColor = ((gsDisplacementColor * u_multiplier.x) - (u_multiplier.x*0.5));

    vec2 uvBase;
    uvBase.x = uv.x + gsDisplacementColor;
    uvBase.y = uv.y;

    vec4 baseColor = texture2D(u_texture, uvBase);

    gl_FragColor.rgb = baseColor.rgb * u_materialDiffuse.rgb;
    gl_FragColor.a = baseColor.a * u_materialDiffuse.a;

}
