attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_projectionMatrix;
uniform highp mat4 u_modelMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_viewMatrix;

varying mediump vec2 v_texCoord;

void main() {
	
	float scalingFactor = sqrt(u_modelMatrix[0][0] * u_modelMatrix[0][0] + u_modelMatrix[0][1]* u_modelMatrix[0][1] + u_modelMatrix[0][2] * u_modelMatrix[0][2]);
	mat4 norot = u_modelMatrix;
	
	norot[0][0] = scalingFactor;
	norot[0][1] = 0.0;
	norot[0][2] = 0.0;
	
	norot[1][0] = 0.0;
	norot[1][1] = scalingFactor;
	norot[1][2] = 0.0;
	
	norot[2][0] = 0.0;
	norot[2][1] = 0.0;
	norot[2][2] = scalingFactor;
	
	gl_Position = u_projectionMatrix * u_viewMatrix * norot * a_position;
	
	v_texCoord = a_texCoord;
}