attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_normal;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	v_texCoord = a_texCoord;
	lowp vec3 v_view = -normalize(u_modelViewMatrix * a_position).rgb;
	lowp vec3 v_normal = normalize(u_modelViewMatrix * vec4(a_normal, 0)).rgb;
	v_color.a *= max(0.0, dot(v_view, v_normal));
}