varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform vec4 u_options;
uniform vec4 u_color4;

void main() {
	float spread = u_options.z;
	float ramp_coord_y = 1.0 - v_color.a * u_color4.a;
	vec4 col = texture2D(u_texture, v_texCoord);
	vec4 ramp = texture2D(u_texture1, lowp vec2(col.r, 1.0 - ramp_coord_y));
	gl_FragColor = 
	// color
	vec4(v_color.rgb,1.0) * ramp * 
	// alpha
	smoothstep(max((ramp_coord_y)-spread, 0.0), min((ramp_coord_y)+spread, 1.0), col.b) * v_color.a;
}
