varying lowp vec4 v_color;
varying lowp vec2 v_mainTexCoord;
varying lowp vec2 v_dissolveTexCoord;

varying highp float v_dissolve;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

uniform vec4 u_smoothness_min_max;

void main()
{
	vec4 texColor = texture2D(u_texture, v_mainTexCoord);

	//apply dissolve alpha
	vec4 dissolveColor = texture2D(u_texture1, v_dissolveTexCoord);
	float dissolveTexValue = dissolveColor.a;
	float dissolveValue = smoothstep(v_dissolve - u_smoothness_min_max.x, v_dissolve + u_smoothness_min_max.y, dissolveTexValue);

	gl_FragColor = vec4(texColor.rgb * v_color.rgb, texColor.a * v_color.a * dissolveValue);
}
