#include "utils/Utils.inc"

attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp float u_time;
uniform highp vec4 u_color4;

uniform lowp vec4 u_main_scroll_tiling;
uniform lowp vec4 u_dissolve_scroll_tiling;

varying lowp vec4 v_color;
varying lowp vec2 v_mainTexCoord;
varying lowp vec2 v_dissolveTexCoord;

varying highp float v_dissolve;

void main()
{
	gl_Position = u_modelViewProjectionMatrix * a_position;

	// calculate main UVs
	v_mainTexCoord = CalculateCoordsByTime(
		a_texCoord,
		vec2(0.0),
		u_main_scroll_tiling.zw,
		u_main_scroll_tiling.xy,
		u_time);

	// calculate dissolve factor
	v_dissolve = 1.0 - u_color4.a;

	// calculate dissolve UVs
	v_dissolveTexCoord = CalculateCoordsByTime(
		a_texCoord,
		vec2(0.0),
		u_dissolve_scroll_tiling.zw,
		u_dissolve_scroll_tiling.xy,
		u_time);

		v_color = a_color;
}
