#include "utils/GeometryUtils.inc"

varying lowp vec2 v_mainTexCoord;
varying lowp vec2 v_distortTexRedCoord;
varying lowp float v_distortRedIntensity;
varying lowp vec2 v_distortTexGreenCoord;
varying lowp float v_distortGreenIntensity;
varying lowp vec4 v_color;

uniform sampler2D u_texture; // main texture
uniform sampler2D u_texture1; // distort texture

void main()
{
  vec2 distort;

  //distort in x by red channel
  float distortRed = texture2D(u_texture1, v_distortTexRedCoord).r;
  distort.x = (distortRed - 0.5) * v_distortRedIntensity;

  //distort in y by green channel
  float distortGreen = texture2D(u_texture1, v_distortTexGreenCoord).g;
  distort.y = (distortGreen - 0.5) * v_distortGreenIntensity;

  //distort intensity by static blue channel
  float distortIntensityBlue = texture2D(u_texture1, v_mainTexCoord).b;

  //main color
  vec2 mainTexDistortCoord = v_mainTexCoord + distort * distortIntensityBlue;
  vec4 mainTexColor = texture2D(u_texture, mainTexDistortCoord);

  gl_FragColor = mainTexColor * v_color;
}
