#include "utils/Utils.inc"

attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp float u_time;

uniform lowp vec4 u_main_scroll_tiling; // {scroll speed x, scroll speed y, tiling x, tiling y}
uniform lowp vec4 u_distort_red_pos_tiling; //{pos x, pos y, tiling x, tiling y}
uniform lowp vec4 u_distort_red_scroll_intensity; //{scroll speed x, scroll speed y, intensity}
uniform lowp vec4 u_distort_green_pos_tiling; //{pos x, pos y, tiling x, tiling y}
uniform lowp vec4 u_distort_green_scroll_intensity; //{scroll speed x, scroll speed y, intensity}

varying lowp vec2 v_mainTexCoord;
varying lowp vec2 v_distortTexRedCoord;
varying lowp float v_distortRedIntensity;
varying lowp vec2 v_distortTexGreenCoord;
varying lowp float v_distortGreenIntensity;
varying lowp vec4 v_color;

void main()
{
	gl_Position = u_modelViewProjectionMatrix * a_position;

	// calculate main UVs
	v_mainTexCoord = CalculateCoordsByTime(
		a_texCoord,
		vec2(0.0),
		u_main_scroll_tiling.zw,
		u_main_scroll_tiling.xy,
		u_time);

	// calculate distort channel red UVs and intensity
	v_distortTexRedCoord = CalculateCoordsByTime(
		a_texCoord,
		u_distort_red_pos_tiling.xy,
		u_distort_red_pos_tiling.zw,
		u_distort_red_scroll_intensity.xy,
		u_time);
	v_distortRedIntensity = u_distort_red_scroll_intensity.z;

	// calculate distort channel green UVs and intensity
	v_distortTexGreenCoord = CalculateCoordsByTime(
		a_texCoord,
		u_distort_green_pos_tiling.xy,
		u_distort_green_pos_tiling.zw,
		u_distort_green_scroll_intensity.xy,
		u_time);
	v_distortGreenIntensity = u_distort_green_scroll_intensity.z;

	v_color = a_color;
}
