#include "utils/GeometryUtils.inc"

varying lowp vec2 v_mainTexCoord;
varying lowp vec2 v_maskTexCoord;
varying lowp vec4 v_color;

uniform sampler2D u_texture; // main texture
uniform sampler2D u_texture1; // mask texture

void main()
{
  //main color
  vec4 mainTexColor = texture2D(u_texture, v_mainTexCoord);

  //mask alpha
  float hasToMak = IsInsideRectangle(v_maskTexCoord, vec2(0.5), vec2(1.0));
  float maskTexAlpha = texture2D(u_texture1, v_maskTexCoord).a * hasToMak;

  gl_FragColor = mainTexColor * v_color;
  gl_FragColor.a *= maskTexAlpha;
}
