varying lowp vec4 v_color;
varying lowp vec4 v_outlineColor;
varying lowp vec2 v_texCoord;
varying mediump vec2 v_weight;

uniform sampler2D u_texture;

void main() {
	lowp float sdf = texture2D(u_texture, v_texCoord.xy).a;
	lowp float a = smoothstep(v_weight.x, v_weight.y, sdf);
	lowp float b = smoothstep(v_weight.x*v_outlineColor.a, v_weight.y*v_outlineColor.a, sdf);
	lowp vec3 outColor = mix(v_outlineColor.rgb, v_color.rgb, floor(v_outlineColor.a)); // if alpha is not exactly 1(255) then use outline color, otherwise use text color. to avoid ugly small outline
	outColor = mix(outColor, v_color.rgb, a);
	gl_FragColor = vec4( outColor.r,outColor.g,outColor.b,v_color.a*b);
}
