attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;
attribute lowp vec3 a_textScale;
attribute lowp vec3 a_textOutline;
attribute lowp vec4 a_outlineColor;
attribute lowp vec4 a_textColor;
attribute lowp vec4 a_color;

uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_viewMatrix;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_color4;
uniform lowp vec4 u_materialAmbient;

varying lowp vec4 v_color;
varying lowp vec4 v_outlineColor;
varying lowp vec4 v_textColor;

varying mediump vec2 v_texCoord;
varying mediump vec2 v_weight;
varying lowp vec3 v_textScale;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_textScale = vec3(2.5,2.5,1.0);
	v_texCoord = a_texCoord;
	mat3 transform = mat3(u_viewMatrix[0].xyz,u_viewMatrix[1].xyz,u_viewMatrix[2].xyz);
	vec3 another = transform * v_textScale;
	
	v_weight = vec2(0.5 - clamp(exp(-another.x) * 0.5, 0.0, 0.5), 0.5 + clamp(exp(-another.y) * 0.5, 0.0, 0.5));
	v_outlineColor = a_outlineColor;
	v_textColor = a_textColor;
	v_color = a_color * u_color4;
}

