attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;
attribute lowp vec4 a_styleParams;
attribute lowp vec4 a_glyphParams;
attribute lowp vec4 a_textureParams;
 
uniform highp mat4 u_modelViewProjectionMatrix;
 
varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp vec4 v_styleParams;
varying lowp vec4 v_glyphParams;
varying lowp vec2 v_textureGlyph;
varying lowp vec2 v_textureParagraph;
 
void main() {
    gl_Position = u_modelViewProjectionMatrix * a_position;
    v_color = a_color;
    v_texCoord = a_texCoord;
    v_styleParams = a_styleParams;
    v_glyphParams = a_glyphParams;
    v_textureGlyph = vec2(a_textureParams.xy);
    v_textureParagraph = vec2(a_textureParams.zw);
}