varying vec4 v_color;
varying vec2 v_texCoord;
varying vec4 v_styleParams;
varying vec4 v_glyphParams;
 
uniform sampler2D u_texture;
uniform vec4 u_params;
 
void main() {   
    float packedAlpha = texture2D(u_texture, v_texCoord).a;
    float glyphEdge = v_glyphParams.x;
    float fieldStep = v_glyphParams.y;
    float softnessSize = v_glyphParams.z;
    
    float bval = step(1.5, v_glyphParams.w);
     
    float outlineSize = mix(0.0, u_params.x, bval);
     
    float outlineAmount = outlineSize * fieldStep;
    float edge = glyphEdge - outlineAmount;
    float t0 = smoothstep(edge - softnessSize * fieldStep, edge + fieldStep, packedAlpha);
    float t1 = step(edge - (softnessSize * fieldStep), packedAlpha);
    float threshold = mix(t0, t1, bval);
    vec4 c = vec4(v_color.rgb, threshold * v_color.a);
    c.a = mix(c.a, smoothstep(edge - (fieldStep + fieldStep), edge, packedAlpha) * c.a, bval);
    gl_FragColor = c;
}