varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp vec4 v_styleParams;
varying lowp vec4 v_glyphParams;
varying lowp vec2 v_textureParagraph;
 
uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform lowp vec4 u_params;
 
void main() {   
    mediump float packedAlpha = texture2D(u_texture1, v_texCoord).a;
    lowp float glyphEdge = v_glyphParams.x;
    lowp float fieldStep = v_glyphParams.y;
    lowp float softnessSize = v_glyphParams.z;
    
    float eval = step(0.1, v_glyphParams.w);
    float bval = step(1.5, v_glyphParams.w);
     
    float outlineSize = mix(0.0, u_params.x, bval);
     
    float outlineAmount = outlineSize * fieldStep;
    float edge = glyphEdge - outlineAmount;
    float t0 = smoothstep(edge - softnessSize * fieldStep, edge + fieldStep, packedAlpha);
    float t1 = step(edge - (softnessSize * fieldStep), packedAlpha);
    float threshold = mix(t0, t1, bval);
    vec4 c = vec4(v_color.rgb, threshold * v_color.a);
    c.a = mix(c.a, smoothstep(edge - 2.0 * fieldStep, edge, packedAlpha) * c.a, bval);
 
    vec3 overlay = texture2D(u_texture, v_textureParagraph).rgb;
    gl_FragColor = mix(vec4(overlay.xyz, 1.0) * c, c, eval);
}