varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
// u_options: x=fresnel_brightness, y=fresnel_contrast, z=mask X tiling, w=mask Y tiling
uniform vec4 u_options;
// clamp_values: x=min clamp, y=max clamp, z=void, w=void
uniform vec4 clamp_values;
uniform vec4 u_color4;

void main() {
	float fresnel_brightness = u_options.x;
	float fresnel_contrast = u_options.y;
	vec4 c = texture2D(u_texture, v_texCoord);
	vec4 fresnel_border = texture2D(u_texture1, v_texCoord*vec2(u_options.z,u_options.w));
	float fresnel = 1.0-clamp(pow(fresnel_brightness*( 1.0-v_color.a*u_color4.a),fresnel_contrast),0.0,1.0);
	float final_fresnel = clamp(fresnel_border.r * fresnel + fresnel,0.0,1.0);
	float final_fresnel_step = smoothstep(clamp_values.x,clamp_values.y,final_fresnel);
	gl_FragColor = vec4(c.rgb,final_fresnel_step);
}