varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying highp float timing;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

// u_options: x=fresnel_brightness, y=fresnel_contrast, z=void, w=void
uniform vec4 u_options;
uniform vec4 u_color4;
varying highp float dotproduct;

void main() {
	float fresnel_brightness = u_options.x;
	float fresnel_contrast = u_options.y;
	
	float fresnel = clamp(pow(fresnel_brightness*(dotproduct*u_color4.a),fresnel_contrast),0.0,1.0);
	vec4 fresnel_color = vec4 (v_color.rgb * fresnel, clamp(timing,0.0,1.0) *v_color.a);
	gl_FragColor = fresnel_color;
}