/*
	Fog
	inputs:
	glpos			from shader glpos
					decides how close to the camera the darkening will happen
	closeDarkenColor
					multiplies colors
	u_closeDarken	
					color for darkening, defaults to purple, users can change this by adding a uniform to material
*/


//uniform lowp vec4 u_darkenColor;
uniform mediump vec4 u_closeDarken;

float closeDarken(vec4 glpos) {
	float closeDarken = clamp(glpos.w/3000.0, 0.7, 1.0);
	return closeDarken;
}

vec3 closeDarkenColor(vec4 u_closeDarken) {
	vec3 closeDarkenColor = vec3(u_closeDarken.rgb * u_closeDarken.rgb * u_closeDarken.rgb);
	return closeDarkenColor;
}