#ifdef GL_ES
precision highp float;
#endif

attribute highp vec4 a_position;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_normal;
attribute mediump vec3 a_tangent;
attribute mediump vec3 a_binormal;

uniform highp mat4 u_directionalLightMatrix; // Light matrix in world space
uniform lowp vec4 u_directionalLightColor; // Dir Color in RGB , intensity in A
uniform lowp vec4 u_ambientLightColor;// Ambient Color in RGB, intensity in A (contrast)

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelMatrix;
uniform highp mat4 u_viewMatrix;
	
uniform highp float u_time;

varying mediump vec2 v_texCoord0;
varying mediump vec3 v_normal;
varying mediump vec3 v_tangent;
varying mediump vec3 v_binormal;
varying mediump vec3 v_camDir;

void main() {
	gl_Position = (u_modelViewProjectionMatrix * a_position);
		
	v_normal = normalize((u_modelMatrix * vec4(a_normal, 0.0))).xyz;
	v_tangent = normalize((u_modelMatrix * vec4(a_tangent, 0.0))).xyz;
	v_binormal = normalize((u_modelMatrix * vec4(a_binormal, 0.0))).xyz;
	v_camDir = vec3(u_viewMatrix[0][2], u_viewMatrix[1][2], u_viewMatrix[2][2]);

	v_texCoord0 = a_texCoord;
}

