#ifdef GL_ES
precision highp float;
#endif

#include "includes/world_bend.inc"

attribute highp vec4 a_position;
attribute lowp vec2 a_texCoord;
attribute lowp vec4 a_color;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
	
uniform lowp vec4 u_color4;
uniform lowp vec4 u_materialAmbient;

varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

void main() {
	v_color = a_color * u_color4;
	v_texCoord = a_texCoord;
	
	// Bending
	vec4 glpos = u_modelViewProjectionMatrix * a_position;
	gl_Position = world_bend(u_modelViewMatrix * a_position, glpos);
}