attribute mediump vec4 a_position;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_normal;
attribute mediump vec3 a_tangent;

uniform mediump mat4 u_modelViewProjectionMatrix;
uniform mediump mat4 u_modelMatrix;

uniform highp float u_time;
varying mediump vec2 v_texCoord0;
varying mediump vec3 v_L2dir;

varying mediump vec3 v_normalSpaceTransformX;
varying mediump vec3 v_normalSpaceTransformY;
varying mediump vec3 v_normalSpaceTransformZ;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	
	/* Send currently drawn pixel to fragment shader */
	highp vec2 v_pixelPos = vec2(gl_Position.x+sin(u_time), gl_Position.y+cos(u_time)) * 0.1;
	
	v_texCoord0 = a_texCoord;

	/* Create TBN matrix in fragment shader */
	v_normalSpaceTransformX = normalize((u_modelMatrix * vec4(a_normal, 0.0))).xyz;
	v_normalSpaceTransformY = normalize((u_modelMatrix * vec4(a_tangent, 0.0))).xyz;
	v_normalSpaceTransformZ = normalize(cross(v_normalSpaceTransformX, v_normalSpaceTransformY));
	
	//v_L1dir = normalize(vec3(-0.4+v_pixelPos.x, -0.3+v_pixelPos.y, 1.0));
	v_L2dir = normalize(vec3(-0.3-v_pixelPos.x, -0.4-v_pixelPos.y, 1.0));
}