#ifdef GL_ES
precision highp float;
#endif

#include "includes/world_bend.inc"

attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec2 a_texCoord2;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_projectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_viewMatrix;

uniform lowp vec4 u_options;
	
varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying mediump vec2 v_texCoord2;

void main() {
	vec4 pos = u_modelViewMatrix * a_position + vec4(a_texCoord2 * 0.5, 0, 0);
	// Bending
	vec4 glpos = u_projectionMatrix * pos;
	gl_Position = world_bend(u_modelViewMatrix * a_position, glpos);
	
	v_color = a_color * vec4(1.0, 1.0, 1.0, smoothstep(u_options.w, u_options.z, gl_Position.z));
	v_texCoord = a_texCoord;
	v_texCoord2 = a_texCoord2;
}
