attribute highp vec4 a_position;
attribute highp vec4 a_color;
attribute highp vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp float u_time;

uniform vec4 u_pulse_timing; //speed, offset, min glow, void

varying highp vec4 v_color;
varying highp vec2 v_texCoord;
varying highp float timing;

void main()
{
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	v_texCoord = a_texCoord;
	
	//Pulse Timing
	highp float speed;
	highp float offset;
	highp float min_glow;
	
	speed = u_pulse_timing.x;
	offset = u_pulse_timing.y;
	min_glow = clamp(u_pulse_timing.z,0.0,1.0);
	
	timing = fract((cos ((u_time+offset)*speed)+1.0)*0.5*(1.0-min_glow)+(min_glow));
}