varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
//u_materialAmbient used for Occlusion: rgb=color, a=occlusion intensity;
uniform lowp vec4 u_materialAmbient;
//u_materialDiffuse used for Fresnel: rgb=color, a=fresnel opacity;
uniform lowp vec4 u_materialDiffuse;

// u_options: x=fresnel_brightness, y=fresnel_contrast, z=void, w=void
uniform vec4 u_options;
uniform vec4 u_color4;
varying highp float dotproduct;

void main() {
	float fresnel_brightness = u_options.x;
	float fresnel_contrast = u_options.y;
	vec4 c = texture2D(u_texture, v_texCoord);
	float smoke_mask = mix(1.0-u_materialAmbient.a,1.0,c.r);
	vec3 smoke_color = v_color.rgb;
	vec3 occlusion_color = u_materialAmbient.rgb;
	vec3 smoke_occluded = mix(occlusion_color,smoke_color,smoke_mask);
	float fresnel = clamp(pow(fresnel_brightness*(1.0-dotproduct*u_color4.a),fresnel_contrast),0.0,1.0);
	//float fresnel = clamp(pow(fresnel_brightness*(dotproduct*u_color4.a),fresnel_contrast),0.0,1.0);
	vec4 fresnel_color = vec4 (u_materialDiffuse.rgb * fresnel, u_materialDiffuse.a);
	vec3 smoke_final = mix(smoke_occluded,fresnel_color.rgb,fresnel*fresnel_color.a);
	//gl_FragColor = vec4(vec3(fresnel),1.0);
	//gl_FragColor = vec4(fresnel_color.rgb*fresnel_color.a,1.0);
	//gl_FragColor = vec4(smoke_final*(fresnel_color.rgb*fresnel_color.a),v_color.a*c.a);
	gl_FragColor = vec4(smoke_final,v_color.a*c.a);
}