attribute highp vec4 a_position;
attribute lowp vec4 a_color;
uniform lowp vec4 u_color4;
attribute mediump vec2 a_texCoord;
attribute mediump vec3 a_normal;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform lowp vec4 u_materialAmbient;
uniform lowp vec4 u_materialDiffuse;
uniform highp float u_time;

uniform vec4 u_pulse_timing; //speed, offset, min glow, void

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying highp float dotproduct;
varying highp float timing;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color * u_color4;
	v_texCoord = a_texCoord;
	lowp vec3 v_view = -normalize(u_modelViewMatrix * a_position).rgb;
	lowp vec3 v_normal = normalize(u_modelViewMatrix * vec4(a_normal, 0.0)).rgb;
	dotproduct = max(0.0, dot(v_view, v_normal));
	
	
	//Pulse Timing
	highp float speed;
	highp float offset;
	highp float min_glow;
	
	speed = u_pulse_timing.x;
	offset = u_pulse_timing.y;
	min_glow = clamp(u_pulse_timing.z,0.0,1.0);
	
	timing = fract((cos ((u_time+offset)*speed)+1.0)*0.5*(1.0-min_glow)+(min_glow));
}