varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
//u_materialAmbient used for Occlusion: rgb=color, a=occlusion intensity;
uniform lowp vec4 u_materialAmbient;
//u_materialDiffuse used for Fresnel: rgb=color, a=fresnel opacity;
uniform lowp vec4 u_materialDiffuse;

// u_options: x=fresnel_brightness, y=fresnel_contrast, z=void, w=void
uniform vec4 u_options;
uniform vec4 u_color4;
varying highp float dotproduct;

void main() {
	float fresnel_brightness = u_options.x;
	float fresnel_contrast = u_options.y;
	vec4 texColor = texture2D(u_texture, v_texCoord);
	// vec4 texColor = texColor * UV_Params.xy;
	
	float fresnel = clamp(pow(fresnel_brightness*(1.0-dotproduct*u_color4.a),fresnel_contrast),0.0,1.0);
	
	vec3 fresnel_color = vec3 (u_materialDiffuse.rgb * fresnel) * u_materialDiffuse.a;
	
	gl_FragColor = vec4(v_color.rgb * texColor.rgb + fresnel_color, texColor.a);
}