#ifdef GL_ES
precision highp float;
#endif
#include "includes/common_functions.inc"
#include "includes/world_bend.inc"
#include "includes/fog.inc"
#include "includes/close_darken.inc"

attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform lowp vec4 u_color4;

uniform highp float u_time;
uniform highp vec4 ScrollSpeed;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_materialAmbient;
uniform highp mat4 u_modelViewMatrix;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

void main() {
	vec4 glpos = u_modelViewProjectionMatrix * a_position;
	gl_Position = world_bend(u_modelViewMatrix * a_position, glpos);
	v_color = a_color * vec4(u_materialAmbient.a, u_materialAmbient.a, u_materialAmbient.a, 1.0)* u_color4;
	v_texCoord = a_texCoord;

	v_texCoord.x += fract(u_time * ScrollSpeed.x);// * (u_time * ScrollSpeed.w + sin(u_time * ScrollSpeed.z) * ScrollSpeed.w);
	v_texCoord.y += fract(u_time * ScrollSpeed.y);// * (u_time * ScrollSpeed.w + sin(u_time * ScrollSpeed.z) * ScrollSpeed.w);
	
	
}