attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp float u_time;
uniform mediump vec4 u_dist_tiling_scroll1;
uniform mediump vec4 u_dist_tiling_scroll2;

uniform highp vec4 uv_tiling_scroll;
varying lowp vec2 scrollUV0;

varying lowp vec4 v_ucolor;
varying lowp vec4 v_vcolor;

varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

varying lowp vec2 v_texCoord;
varying lowp vec2 v_texCoord2;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/

void main()
{
	v_vcolor = a_color;
	v_texCoord = a_texCoord;
	v_texCoord2 = a_texCoord;
	v_scrollUV1 = v_texCoord2.xy*u_dist_tiling_scroll1.xy+fract(u_time*u_dist_tiling_scroll1.zw);
	v_scrollUV2 = v_texCoord2.xy*u_dist_tiling_scroll2.xy+fract(u_time*u_dist_tiling_scroll2.zw);
	
	gl_Position = u_modelViewProjectionMatrix * a_position;
	
	//ONLY IF WE NEED TO TWEAK 1st UV CHANNEL
	scrollUV0 = v_texCoord.xy*uv_tiling_scroll.xy+fract(u_time*uv_tiling_scroll.zw);
}