varying lowp vec2 v_texCoord;
varying lowp vec2 v_texCoord2;
varying lowp vec4 v_ucolor;
varying lowp vec4 v_vcolor;

uniform lowp vec4 u_color4;
uniform sampler2D u_texture;
uniform sampler2D u_texture1;

uniform mediump vec4 u_dist_strength;
uniform highp vec4 u_options;

varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/

void main()
{
	float spread = u_options.z;
	float val = 1.0 - v_vcolor.a;
	vec4 dist_strength = u_dist_strength * v_vcolor;
	vec2 distortTex1 = texture2D(u_texture1, v_scrollUV1).rg * 2.0-1.0;
	vec2 distortTex2 = texture2D(u_texture1, v_scrollUV2).rg * 2.0-1.0;
	vec2 final_uv_distortion1 = dist_strength.xy*distortTex1.rg;
	vec2 final_uv_distortion2 = dist_strength.zw*distortTex2.rg;
	
	vec4 texColor = texture2D(u_texture, v_texCoord+(final_uv_distortion1+final_uv_distortion2));
	float dissolve_grad= smoothstep(max(val-spread, 0.0), min(val+spread, 1.0), texColor.g);
	
	gl_FragColor = vec4(texColor.r * v_vcolor.rgb, texColor.a*dissolve_grad);

}