attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
attribute mediump vec2 a_texCoord2;

uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_projectionMatrix;
uniform highp float u_time;
uniform mediump vec4 u_dist_tiling_scroll1;
uniform mediump vec4 u_dist_tiling_scroll2;
uniform highp vec4 u_options;

varying lowp vec4 v_vcolor;

varying lowp vec2 v_tiledissolve;
varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

varying lowp vec2 v_texCoord;
varying lowp vec2 v_texCoord2;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/

void main()
{
	vec4 pos = u_modelViewMatrix * a_position + vec4(a_texCoord2*0.5,0,0);
	gl_Position = u_projectionMatrix * pos;
	
	v_vcolor = a_color;
	v_texCoord = a_texCoord;
	v_texCoord2 = a_texCoord2;
	v_tiledissolve = v_texCoord.xy*u_options.xy;
	v_scrollUV1 = v_texCoord.xy*u_dist_tiling_scroll1.xy+fract(u_time*u_dist_tiling_scroll1.zw);
	v_scrollUV2 = v_texCoord.xy*u_dist_tiling_scroll2.xy+fract(u_time*u_dist_tiling_scroll2.zw);

}