attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute highp vec3 a_normal;
attribute lowp vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp float u_time;
//u_materialAmbient used for Foam Color;
uniform lowp vec4 u_materialAmbient;
uniform mediump vec4 u_dist_tiling_scroll1;
uniform mediump vec4 u_dist_tiling_scroll2;

uniform mediump vec4 u_dist_spray_tiling_scroll1;
uniform mediump vec4 u_dist_spray_tiling_scroll2;

uniform highp vec4 foam1_tiling_scroll;
uniform highp vec4 foam2_tiling_scroll;
uniform highp vec4 caustics1_tiling_scroll;
uniform highp vec4 caustics2_tiling_scroll;
varying lowp vec2 scrollUV0;
varying lowp vec2 scrollUVFoam1;
varying lowp vec2 scrollUVFoam2;
varying lowp vec2 scrollUVCaustics1;
varying lowp vec2 scrollUVCaustics2;

varying lowp vec4 v_ucolor;
varying highp vec4 v_vcolor;

varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

varying lowp vec2 v_scrollSpray1;
varying lowp vec2 v_scrollSpray2;

varying highp vec2 v_texCoord;
varying highp vec2 v_texCoord2;

uniform highp vec4 WaveAmplitude;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/

void main()
{
	v_vcolor = a_color;
	v_texCoord = a_texCoord;
	v_scrollUV1 = v_texCoord.xy*u_dist_tiling_scroll1.xy+fract(u_time*u_dist_tiling_scroll1.zw);
	v_scrollUV2 = v_texCoord.xy*u_dist_tiling_scroll2.xy+fract(u_time*u_dist_tiling_scroll2.zw);
	
	v_scrollSpray1 = v_texCoord.xy*u_dist_spray_tiling_scroll1.xy+fract(u_time*u_dist_spray_tiling_scroll1.zw);
	v_scrollSpray2 = v_texCoord.xy*u_dist_spray_tiling_scroll2.xy+fract(u_time*u_dist_spray_tiling_scroll2.zw);
	
	//gl_Position = u_modelViewProjectionMatrix * a_position;
	
	float s = (sin(u_time * WaveAmplitude.z + (a_position.y * WaveAmplitude.x)) * WaveAmplitude.w * v_vcolor.a);
	vec3 newPos = a_position.xyz + a_normal * s;
	
	gl_Position = u_modelViewProjectionMatrix * vec4(newPos, 1.0);
	
	//ONLY IF WE NEED TO TWEAK 1st UV CHANNEL
	scrollUVFoam1 = v_texCoord.xy*foam1_tiling_scroll.xy+fract(u_time*foam1_tiling_scroll.zw);
	scrollUVFoam2 = v_texCoord.xy*foam2_tiling_scroll.xy+fract(u_time*foam2_tiling_scroll.zw);
	scrollUVCaustics1 = v_texCoord.xy*caustics1_tiling_scroll.xy+fract(u_time*caustics1_tiling_scroll.zw);
	scrollUVCaustics2 = v_texCoord.xy*caustics2_tiling_scroll.xy+fract(u_time*caustics2_tiling_scroll.zw);
	
	vec2 vertexcorrected = vec2 (pow(v_vcolor.r,1.0/2.2),pow(v_vcolor.g,1.0/2.2));	
	//vec2 vertexcorrected = v_vcolor.rg;	
	scrollUV0 = v_texCoord.xy + (v_vcolor.rg*2.0-1.0)*1.5;
}