// * User input * //
uniform mediump sampler2D u_texture;

// Data IN FROM VERTEX SHADER

varying lowp vec4 v_color;
varying lowp vec2 v_texCoord0;
varying lowp vec2 v_texCoord1;
varying lowp vec2 v_texCoord2;
//varying lowp vec2 v_texCoord3;
	
uniform lowp vec4 u_settings;
uniform lowp vec4 u_color4;
	
uniform lowp vec4 u_materialDiffuse;

float saturate(float x)
{
  return max(0.0, min(1.0, x));
}

void main() {
	vec4 coord0 = texture2D(u_texture, v_texCoord0);
	vec4 coord2 = texture2D(u_texture, v_texCoord2);
	//float bignoise = ((texture2D(u_texture, v_texCoord3).a));// * 10.0);// * 0.75) + 0.25;

	float water_noise1 = coord0.r;
	float water_noise2 = texture2D(u_texture, v_texCoord1).r;
	float water_foam = max(0.0, (coord0.g-0.5) + (coord2.g-0.5));

	float whirls = saturate((water_noise1-0.5) + (water_noise2-0.5));
	float foam = saturate((coord0.g-0.5) + (coord2.g-0.5));
	float ridgemask = saturate((coord0.b-0.5) + (coord2.b-0.5));
	
	// Apply the mask
	foam *= ridgemask;
	whirls *= ridgemask;
	
	float fade = (fract(v_texCoord0.y));
	fade = fade * fade * fade; // #dealwithit
	
	ridgemask *= fade;
	foam += ridgemask;
	ridgemask *= fade;
	
	float alpha = (whirls + foam) * fade + ridgemask;
	alpha *= v_color.a * u_color4.a;// * /*water_foam * */ (bignoise);
	
	gl_FragColor = vec4(u_color4.rgb + u_materialDiffuse.rgb * ((whirls+ridgemask) * 0.5), alpha * u_color4.a );
	//gl_FragColor = vec4(vec3(ridgemask+ridgemask),1.0);
}