#ifdef GL_ES
precision highp float;
#endif

#include "includes/world_bend.inc"
#include "includes/fog.inc"

attribute highp vec4 a_position;
attribute highp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;

uniform highp float u_time;

uniform lowp vec4 u_settings;

// DATA OUT TO PIXEL SHADER
varying lowp vec2 v_texCoord0;
varying lowp vec2 v_texCoord1;
varying lowp vec2 v_texCoord2;
varying lowp vec4 v_color;

void main() {
	float ScrollSpeed = -u_settings.x;
	float Offset = u_settings.z;
	
	v_texCoord0 = a_texCoord;
	
	vec4 Po = a_position;
	
	vec4 glpos = u_modelViewProjectionMatrix * a_position;
	gl_Position = world_bend(u_modelViewMatrix * Po, glpos);
	
	v_texCoord0.y += fract((u_time * ScrollSpeed)) + Po.z * Offset;
	v_texCoord2 = v_texCoord0;
	
	v_texCoord0.x += mod((u_time * ScrollSpeed), 2.0) * -1.0;// * 2.0;
	v_texCoord2.x *= 0.5;
	v_texCoord2.x += mod((u_time * ScrollSpeed) * 2.0, 2.0); // for secondary foam
			
	v_texCoord1 = v_texCoord0;
	v_texCoord1.x = v_texCoord1.x * -0.5;
	v_texCoord1.x += mod((u_time * ScrollSpeed) * 0.5, 2.0); // for secondary noise
	v_texCoord1.y -= mod((u_time * ScrollSpeed) * 0.5, 2.0); //
	
	v_color = a_color;
}

